/*
* $Header: https://oberon.oapd.inaf.it/shins/trunk/shins/src/iif/Interface/Ltcs/Iif/IifInstrum.h 374 2018-01-11 11:43:51Z depa $
* @author R. J. Mathar
* @since 2017-01-17
*/

#pragma once

#include <string>
#include <Ltcs/Iif/IifStation.h>

namespace Ltcs
{
	/** enumeration of some instruments, including LUCIFER, Linc-Nirvana and LBTI
	*/
	enum IifInstr { NONE, LUCI, LN, LBTI, LBC, MODS, PEPSIPOL, 
		PEPSIPFU, LAT, DIMM, IRTC, ILOCATER, SHARK } ;

	/**
	* @brief This class represents one of the LBTI or LBT instruments.
	*/
	class IifInstrum
	{
	public:

		IifInstrum(const enum IifInstr = NONE) ;

		operator Ltcs::IifStation() ;
#if 0
		~IifInstrum() ;
#endif

		std::string toString() const ;
	protected:
	private:
		enum IifInstr ins ;
	} ;
}
